---
title: await
slug: Web/JavaScript/Reference/Operators/await
tags:
  - Function
  - JavaScript
  - Language feature
  - Operator
  - Primary Expression
---
<div>{{jsSidebar("Operators")}}</div>

<p>The <code>await</code> operator is used to wait for a {{jsxref("Promise")}}. It can only be used inside an {{jsxref("Statements/async_function", "async function")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">[<em>rv</em>] = await <em>expression</em>;</pre>

<dl>
 <dt><code>expression</code></dt>
 <dd>A {{jsxref("Promise")}} or any value to wait for.</dd>
 <dt><code>rv</code></dt>
 <dd>
 <p>Returns the fulfilled value of the promise, or the value itself if it's not a <code>Promise</code>.</p>
 </dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>await</code> expression causes <code>async</code> function execution to pause until a <code>Promise</code> is settled (that is, fulfilled or rejected), and to resume execution of the <code>async</code> function after fulfillment. When resumed, the value of the <code>await</code> expression is that of the fulfilled <code>Promise</code>.</p>

<p>If the <code>Promise</code> is rejected, the <code>await</code> expression throws the rejected value.</p>

<p>If the value of the <em>expression</em> following the <code>await</code> operator is not a <code>Promise</code>, it's converted to a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/resolve">resolved Promise</a>.</p>

<p>An <code>await</code> splits execution flow, allowing the caller of the async function to resume execution. After the <code>await</code> defers the continuation of the async function, execution of subsequent statements ensues. If this <code>await</code> is the last expression executed by its function execution continues by returning to the function's caller a pending <code>Promise</code> for completion of the <code>await</code>'s function and resuming execution of that caller.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Awaiting_a_promise_to_be_fulfilled">Awaiting a promise to be fulfilled</h3>

<p>If a <code>Promise</code> is passed to an <code>await</code> expression, it waits for the <code>Promise</code> to be fulfilled and returns the fulfilled value.</p>

<pre class="brush: js notranslate">function resolveAfter2Seconds(x) {
  return new Promise(resolve =&gt; {
    setTimeout(() =&gt; {
      resolve(x);
    }, 2000);
  });
}

async function f1() {
  var x = await resolveAfter2Seconds(10);
  console.log(x); // 10
}

f1();
</pre>

<h3 id="Thenable_objects">Thenable objects</h3>

<p>{{jsxref("Global_Objects/Promise/then", "Thenable objects")}} will be fulfilled just the same.</p>

<pre class="brush: js notranslate">async function f2() {
  const thenable = {
    then: function(resolve, _reject) {
      resolve('resolved!')
    }
  };
  console.log(await thenable); // resolved!
}

f2();
</pre>

<h3 id="Conversion_to_promise">Conversion to promise</h3>

<p>If the value is not a <code>Promise</code>, it converts the value to a resolved <code>Promise</code>, and waits for it.</p>

<pre class="brush: js notranslate">async function f3() {
  var y = await 20;
  console.log(y); // 20
}

f3();</pre>

<h3 id="Promise_rejection">Promise rejection</h3>

<p>If the <code>Promise</code> is rejected, the rejected value is thrown.</p>

<pre class="brush: js notranslate">async function f4() {
  try {
    var z = await Promise.reject(30);
  } catch(e) {
    console.error(e); // 30
  }
}

f4();</pre>

<h3 id="Handling_rejected_promises">Handling rejected promises</h3>

<p>Handle rejected <code>Promise</code> without try block.</p>

<pre class="brush: js notranslate">var response = await promisedFunction().catch((err) =&gt; { console.error(err); });
// response will be undefined if the promise is rejected
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("ESDraft", "#sec-async-function-definitions", "async functions")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.operators.await")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/async_function", "async function")}}</li>
 <li>{{jsxref("Operators/async_function", "async function expression")}}</li>
 <li>{{jsxref("AsyncFunction")}} object</li>
</ul>
